package de.jatitv.commandguiv2.Spigot.system;

import de.jatitv.commandguiv2.Spigot.config.configConverter.ConfigConverterUnderV5;
import de.jatitv.commandguiv2.Spigot.gui.GUIListener;
import de.jatitv.commandguiv2.Spigot.listener.Bungee_Sender_Reciver;
import de.jatitv.commandguiv2.Spigot.useItem.EventsFrom110;
import de.jatitv.commandguiv2.Spigot.cmdManagement.CmdExecuter_GUI;
import de.jatitv.commandguiv2.Spigot.cmdManagement.CmdExecuter_GUIItem;
import de.jatitv.commandguiv2.Spigot.cmdManagement.CmdExecuter_Help;
import de.jatitv.commandguiv2.Spigot.cmdManagement.register.AliasRegister;
import de.jatitv.commandguiv2.Spigot.config.functions.CreateFunctions;
import de.jatitv.commandguiv2.Spigot.config.gui.CreateGUI;
import de.jatitv.commandguiv2.Spigot.config.languages.LanguagesCreate;
import de.jatitv.commandguiv2.Spigot.config.languages.SelectMessages;
import de.jatitv.commandguiv2.Spigot.database.MySQL;
import de.jatitv.commandguiv2.Spigot.listener.PluginEvent;
import de.jatitv.commandguiv2.Spigot.useItem.Events;
import de.jatitv.commandguiv2.Spigot.Main;
import de.jatitv.commandguiv2.Spigot.objects.Obj_Select;
import de.jatitv.commandguiv2.Spigot.config.config.ConfigCreate;
import de.jatitv.commandguiv2.Spigot.config.config.SelectConfig;
import de.jatitv.commandguiv2.Spigot.database.SQLITE;
import de.jatitv.commandguiv2.Spigot.database.SelectDatabase;
import de.jatitv.commandguiv2.Spigot.enums.StorageEnum;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2CmcVersion;
import net.t2code.t2codelib.SPIGOT.api.plugins.T2CpluginCheck;
import net.t2code.t2codelib.SPIGOT.api.update.T2CupdateAPI;
import org.bukkit.Bukkit;
import org.bukkit.plugin.Plugin;

import java.io.*;
import java.sql.SQLException;
import java.util.List;

public class Load {
    static Plugin plugin = Main.getPlugin();

    public static void onLoad(String prefix, List<String> autor, String version, String spigot, int spigotID, String discord, int bstatsID) {

        Long long_ = T2Ctemplate.onLoadHeader(prefix, autor, version, spigot, discord);
        try {
            Debug.debugmsg();
        } catch (Exception e) {
            e.printStackTrace();
        }

        T2Csend.console(prefix + " §8-------------------------------");
        try {
            ConfigConverterUnderV5.renameMainFolder();
        } catch (Exception e) {
            e.printStackTrace();
        }


        if (!new File(Main.getPath(), "config.yml").exists()) {
            try {
                plugin.saveResource("configDeclaration.yml", false);
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                CreateGUI.configCreate();
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                CreateFunctions.create();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        try {
            ConfigCreate.configCreate();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            SelectConfig.onSelect();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            plugin.saveResource("GUIs/guiDeclaration.yml", true);
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            plugin.saveResource("Functions/functionDeclaration.yml", true);
        } catch (Exception e) {
            e.printStackTrace();
        }

        SelectConfig.setConfigVersion();

        if (SelectConfig.getBungee()) {
            if (!Bukkit.getMessenger().isOutgoingChannelRegistered(plugin, "cgui:bungee")) {
                T2Csend.debug(plugin, "registerOutgoingPluginChannel §ecgui:bungee");
                Bukkit.getMessenger().registerOutgoingPluginChannel(plugin, "cgui:bungee");
            }
            if (!Bukkit.getMessenger().isIncomingChannelRegistered(plugin, "cgui:onlinepl")) {
                T2Csend.debug(plugin, "registerIncomingPluginChannel §ecgui:onlinepl");
                Bukkit.getMessenger().registerIncomingPluginChannel(plugin, "cgui:onlinepl", new Bungee_Sender_Reciver());
            }
        }

        if (T2CpluginCheck.papi()) {
            new Papi().register();
        }

        try {
            LanguagesCreate.langCreate();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            Obj_Select.onSelect();
        } catch (Exception e) {
            e.printStackTrace();
        }

        try {
            SelectMessages.onSelect(prefix);
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            SelectConfig.sound(prefix);
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            CmdExecuter_GUI.arg1.put(SelectConfig.getAdminSubCommand(), Permissions.admin+";"+Permissions.giveItemOther+";"+Permissions.info);
        } catch (Exception e) {
            e.printStackTrace();
        }

        T2Csend.console(prefix + " §8-------------------------------");
        loadStorage(prefix);
        T2Csend.console(prefix + " §8-------------------------------");

        if (Main.PaPi) {
            T2Csend.console(prefix + " §2PlaceholderAPI successfully connected!");
        } else {
            T2Csend.console(prefix + " §4PlaceholderAPI could not be connected / found!");
        }

        try {
            Permissions.onPermRegister();
        } catch (Exception e) {
            e.printStackTrace();
        }

        if (SelectConfig.getHelpAlias()) {
            Main.getPlugin().getCommand("commandguihelp").setExecutor(new CmdExecuter_Help());
            T2Csend.debug(plugin, "CommandRegister: commandguihelp");
        }
        Main.getPlugin().getCommand("commandgui").setExecutor(new CmdExecuter_GUI());
        T2Csend.debug(plugin, "CommandRegister: commandgui");
        Main.getPlugin().getCommand("commandgui-item").setExecutor(new CmdExecuter_GUIItem());
        T2Csend.debug(plugin, "CommandRegister: commandgui-item");

        try {
            AliasRegister.onRegister();
        } catch (Exception e) {
            e.printStackTrace();
        }

        Bukkit.getServer().getPluginManager().registerEvents(new GUIListener(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new PluginEvent(), plugin);

        Bukkit.getServer().getPluginManager().registerEvents(new Events(), Main.getPlugin());

        if (!T2CmcVersion.isMc1_8() && !T2CmcVersion.isMc1_9()) {
            Bukkit.getServer().getPluginManager().registerEvents(new EventsFrom110(), plugin);
        }

        T2CupdateAPI.onUpdateCheck(plugin, prefix, spigotID, discord);
        Metrics.Bstats();
        Main.addonLoad();
        T2Ctemplate.onLoadFooter(prefix, long_);
    }

    private static void loadStorage(String prefix) {
        try {
            SelectDatabase.setStorage(StorageEnum.valueOf(SelectConfig.getStorage()));
        } catch (Exception ignored) {
            T2Csend.error( "The storage medium " + SelectConfig.getStorage() + " is not supported!");
            T2Csend.error("Storage medium " + StorageEnum.SQLITE + " is used.");
            SelectDatabase.setStorage(StorageEnum.SQLITE);
        }

        switch (SelectDatabase.getStorage()) {
            case MYSQL:
                T2Csend.console(prefix + " §2Storage medium §6" + SelectDatabase.getStorage() + " §2is used.");
                MySQL.main();
                try {
                    MySQL.query("CREATE TABLE IF NOT EXISTS `gui-item` (" +
                            "    `UUID` VARCHAR(191) NOT NULL COLLATE 'utf8mb4_general_ci'," +
                            "    `Name` TINYTEXT NOT NULL COLLATE 'utf8mb4_general_ci'," +
                            "    `Status` INT(1) NOT NULL DEFAULT '1'," +
                            "    `Slot` INT(1) NULL DEFAULT NULL," +
                            "     UNIQUE INDEX `UUID` (`UUID`)" +
                            ")" +
                            "COLLATE='utf8mb4_general_ci'" +
                            "ENGINE=InnoDB" +
                            ";");
                } catch (Exception e) {
                    Main.sendTryCatch(Load.class, e.getStackTrace()[0]);
                    e.printStackTrace();
                }
                try {
                    MySQL.query("ALTER TABLE `gui-item` ADD COLUMN `Slot` INT(1) NULL DEFAULT NULL AFTER `Status`;");
                } catch (SQLException e) {
                }
                break;
            case YML:
                T2Csend.console(prefix + " §2Storage medium §6" + SelectDatabase.getStorage() + " §2is used.");
                break;
            default:
            case SQLITE:
                T2Csend.console(prefix + " §2Storage medium §6" + SelectDatabase.getStorage() + " §2is used.");
                try {
                    SQLITE.main();
                    SQLITE.query("CREATE TABLE IF NOT EXISTS `gui-item` (" +
                            "UUID TEXT NOT NULL," +
                            "Name TEXT NOT NULL," +
                            "Status INTEGER NOT NULL DEFAULT 1," +
                            "Slot INTEGER," +
                            "PRIMARY KEY(UUID)" +
                            ");");
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                break;
        }
    }
}
